package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import dev.shadowsoffire.apotheosis.adventure.loot.GemLootPoolEntry;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityClamp;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.List;
import java.util.function.Function;
import net.minecraft.util.GsonHelper;
import net.minecraft.world.level.storage.loot.entries.LootPoolEntryContainer;
import net.minecraft.world.level.storage.loot.entries.LootPoolSingletonContainer;
import net.minecraft.world.level.storage.loot.functions.LootItemFunction;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;

public class Serializer extends LootPoolSingletonContainer.Serializer<GemLootPoolEntry> {
  protected GemLootPoolEntry deserialize(JsonObject obj, JsonDeserializationContext context, int weight, int quality, LootItemCondition[] lootConditions, LootItemFunction[] lootFunctions) {
    RarityClamp.Simple rarity;
    if (obj.has("min_rarity") || obj.has("max_rarity")) {
      DynamicHolder<LootRarity> minRarity = RarityRegistry.byLegacyId(GsonHelper.m_13906_(obj, "min_rarity"));
      DynamicHolder<LootRarity> maxRarity = RarityRegistry.byLegacyId(GsonHelper.m_13906_(obj, "max_rarity"));
      rarity = new RarityClamp.Simple(minRarity, maxRarity);
    } else {
      rarity = null;
    } 
    List<String> gems = context.<List<String>>deserialize(GsonHelper.m_13832_(obj, "gems", new JsonArray()), (new Object(this)).getType());
    return new GemLootPoolEntry(rarity, gems.stream().map(net.minecraft.resources.ResourceLocation::new).toList(), weight, quality, lootConditions, lootFunctions);
  }
  
  public void serializeCustom(JsonObject object, GemLootPoolEntry e, JsonSerializationContext ctx) {
    if (e.rarityLimit != null) {
      object.addProperty("min_rarity", e.rarityLimit.min().getId().toString());
      object.addProperty("max_rarity", e.rarityLimit.max().getId().toString());
    } 
    object.add("gems", ctx.serialize(e.gems));
    super.m_7219_(object, (LootPoolSingletonContainer)e, ctx);
  }
}
